#ifdef NATIVE_STATS
extern int GL_nativeFunctionCount;
extern int GL_nativeFunctionCallCount[];
extern char* GL_nativeFunctionNames[];
#define GL_NATIVE_ENTER(env, that, func) GL_nativeFunctionCallCount[func]++;
#define GL_NATIVE_EXIT(env, that, func) 
#else
#define GL_NATIVE_ENTER(env, that, func) 
#define GL_NATIVE_EXIT(env, that, func) 
#endif

typedef enum {
	glAccum_FUNC,
	glAlphaFunc_FUNC,
	glAreTexturesResident_FUNC,
	glArrayElement_FUNC,
	glBegin_FUNC,
	glBindTexture_FUNC,
	glBitmap_FUNC,
	glBlendFunc_FUNC,
	glCallList_FUNC,
	glCallLists__II_3B_FUNC,
	glCallLists__II_3C_FUNC,
	glCallLists__II_3I_FUNC,
	glClear_FUNC,
	glClearAccum_FUNC,
	glClearColor_FUNC,
	glClearDepth_FUNC,
	glClearIndex_FUNC,
	glClearStencil_FUNC,
	glClipPlane_FUNC,
	glColor3b_FUNC,
	glColor3bv_FUNC,
	glColor3d_FUNC,
	glColor3dv_FUNC,
	glColor3f_FUNC,
	glColor3fv_FUNC,
	glColor3i_FUNC,
	glColor3iv_FUNC,
	glColor3s_FUNC,
	glColor3sv_FUNC,
	glColor3ub_FUNC,
	glColor3ubv_FUNC,
	glColor3ui_FUNC,
	glColor3uiv_FUNC,
	glColor3us_FUNC,
	glColor3usv_FUNC,
	glColor4b_FUNC,
	glColor4bv_FUNC,
	glColor4d_FUNC,
	glColor4dv_FUNC,
	glColor4f_FUNC,
	glColor4fv_FUNC,
	glColor4i_FUNC,
	glColor4iv_FUNC,
	glColor4s_FUNC,
	glColor4ub_FUNC,
	glColor4ubv_FUNC,
	glColor4ui_FUNC,
	glColor4uiv_FUNC,
	glColor4us_FUNC,
	glColor4usv_FUNC,
	glColorMask_FUNC,
	glColorMaterial_FUNC,
	glColorPointer_FUNC,
	glCopyPixels_FUNC,
	glCopyTexImage1D_FUNC,
	glCopyTexImage2D_FUNC,
	glCopyTexSubImage1D_FUNC,
	glCopyTexSubImage2D_FUNC,
	glCullFace_FUNC,
	glDeleteLists_FUNC,
	glDeleteTextures_FUNC,
	glDepthFunc_FUNC,
	glDepthMask_FUNC,
	glDepthRange_FUNC,
	glDisable_FUNC,
	glDisableClientState_FUNC,
	glDrawArrays_FUNC,
	glDrawBuffer_FUNC,
	glDrawElements_FUNC,
	glDrawPixels_FUNC,
	glEdgeFlag_FUNC,
	glEdgeFlagPointer_FUNC,
	glEdgeFlagv_FUNC,
	glEnable_FUNC,
	glEnableClientState_FUNC,
	glEnd_FUNC,
	glEndList_FUNC,
	glEvalCoord1d_FUNC,
	glEvalCoord1dv_FUNC,
	glEvalCoord1f_FUNC,
	glEvalCoord1fv_FUNC,
	glEvalCoord2d_FUNC,
	glEvalCoord2dv_FUNC,
	glEvalCoord2f_FUNC,
	glEvalCoord2fv_FUNC,
	glEvalMesh1_FUNC,
	glEvalMesh2_FUNC,
	glEvalPoint1_FUNC,
	glEvalPoint2_FUNC,
	glFeedbackBuffer_FUNC,
	glFinish_FUNC,
	glFlush_FUNC,
	glFogf_FUNC,
	glFogfv_FUNC,
	glFogi_FUNC,
	glFogiv_FUNC,
	glFrontFace_FUNC,
	glFrustum_FUNC,
	glGenLists_FUNC,
	glGenTextures_FUNC,
	glGetBooleanv_FUNC,
	glGetClipPlane_FUNC,
	glGetDoublev_FUNC,
	glGetError_FUNC,
	glGetFloatv_FUNC,
	glGetIntegerv_FUNC,
	glGetLightfv_FUNC,
	glGetLightiv_FUNC,
	glGetMapdv_FUNC,
	glGetMapfv_FUNC,
	glGetMapiv_FUNC,
	glGetMaterialfv_FUNC,
	glGetMaterialiv_FUNC,
	glGetPixelMapfv_FUNC,
	glGetPixelMapuiv_FUNC,
	glGetPixelMapusv_FUNC,
	glGetPointerv_FUNC,
	glGetPolygonStipple_FUNC,
	glGetString_FUNC,
	glGetTexEnvfv_FUNC,
	glGetTexEnviv_FUNC,
	glGetTexGendv_FUNC,
	glGetTexGenfv_FUNC,
	glGetTexGeniv_FUNC,
	glGetTexImage_FUNC,
	glGetTexLevelParameterfv_FUNC,
	glGetTexLevelParameteriv_FUNC,
	glGetTexParameterfv_FUNC,
	glGetTexParameteriv_FUNC,
	glHint_FUNC,
	glIndexMask_FUNC,
	glIndexPointer_FUNC,
	glIndexd_FUNC,
	glIndexdv_FUNC,
	glIndexf_FUNC,
	glIndexfv_FUNC,
	glIndexi_FUNC,
	glIndexiv_FUNC,
	glIndexs_FUNC,
	glIndexsv_FUNC,
	glInitNames_FUNC,
	glInterleavedArrays_FUNC,
	glIsEnabled_FUNC,
	glIsList_FUNC,
	glIsTexture_FUNC,
	glLightModelf_FUNC,
	glLightModelfv_FUNC,
	glLightModeli_FUNC,
	glLightModeliv_FUNC,
	glLightf_FUNC,
	glLightfv_FUNC,
	glLighti_FUNC,
	glLightiv_FUNC,
	glLineStipple_FUNC,
	glLineWidth_FUNC,
	glListBase_FUNC,
	glLoadIdentity_FUNC,
	glLoadMatrixd_FUNC,
	glLoadMatrixf_FUNC,
	glLoadName_FUNC,
	glLogicOp_FUNC,
	glMap1d_FUNC,
	glMap1f_FUNC,
	glMap2d_FUNC,
	glMap2f_FUNC,
	glMapGrid1d_FUNC,
	glMapGrid1f_FUNC,
	glMapGrid2d_FUNC,
	glMapGrid2f_FUNC,
	glMaterialf_FUNC,
	glMaterialfv_FUNC,
	glMateriali_FUNC,
	glMaterialiv_FUNC,
	glMatrixMode_FUNC,
	glMultMatrixd_FUNC,
	glMultMatrixf_FUNC,
	glNewList_FUNC,
	glNormal3b_FUNC,
	glNormal3bv_FUNC,
	glNormal3d_FUNC,
	glNormal3dv_FUNC,
	glNormal3f_FUNC,
	glNormal3fv_FUNC,
	glNormal3i_FUNC,
	glNormal3iv_FUNC,
	glNormal3s_FUNC,
	glNormal3sv_FUNC,
	glNormalPointer_FUNC,
	glOrtho_FUNC,
	glPassThrough_FUNC,
	glPixelMapfv_FUNC,
	glPixelMapuiv_FUNC,
	glPixelMapusv_FUNC,
	glPixelStoref_FUNC,
	glPixelStorei_FUNC,
	glPixelTransferf_FUNC,
	glPixelTransferi_FUNC,
	glPixelZoom_FUNC,
	glPointSize_FUNC,
	glPolygonMode_FUNC,
	glPolygonOffset_FUNC,
	glPolygonStipple_FUNC,
	glPopAttrib_FUNC,
	glPopClientAttrib_FUNC,
	glPopMatrix_FUNC,
	glPopName_FUNC,
	glPrioritizeTextures_FUNC,
	glPushAttrib_FUNC,
	glPushClientAttrib_FUNC,
	glPushMatrix_FUNC,
	glPushName_FUNC,
	glRasterPos2d_FUNC,
	glRasterPos2dv_FUNC,
	glRasterPos2f_FUNC,
	glRasterPos2fv_FUNC,
	glRasterPos2i_FUNC,
	glRasterPos2iv_FUNC,
	glRasterPos2s_FUNC,
	glRasterPos2sv_FUNC,
	glRasterPos3d_FUNC,
	glRasterPos3dv_FUNC,
	glRasterPos3f_FUNC,
	glRasterPos3fv_FUNC,
	glRasterPos3i_FUNC,
	glRasterPos3iv_FUNC,
	glRasterPos3s_FUNC,
	glRasterPos3sv_FUNC,
	glRasterPos4d_FUNC,
	glRasterPos4dv_FUNC,
	glRasterPos4f_FUNC,
	glRasterPos4fv_FUNC,
	glRasterPos4i_FUNC,
	glRasterPos4iv_FUNC,
	glRasterPos4s_FUNC,
	glRasterPos4sv_FUNC,
	glReadBuffer_FUNC,
	glReadPixels_FUNC,
	glRectd_FUNC,
	glRectdv_FUNC,
	glRectf_FUNC,
	glRectfv_FUNC,
	glRecti_FUNC,
	glRectiv_FUNC,
	glRects_FUNC,
	glRectsv_FUNC,
	glRenderMode_FUNC,
	glRotated_FUNC,
	glRotatef_FUNC,
	glScaled_FUNC,
	glScalef_FUNC,
	glScissor_FUNC,
	glSelectBuffer_FUNC,
	glShadeModel_FUNC,
	glStencilFunc_FUNC,
	glStencilMask_FUNC,
	glStencilOp_FUNC,
	glTexCoord1d_FUNC,
	glTexCoord1dv_FUNC,
	glTexCoord1f_FUNC,
	glTexCoord1fv_FUNC,
	glTexCoord1i_FUNC,
	glTexCoord1iv_FUNC,
	glTexCoord1s_FUNC,
	glTexCoord1sv_FUNC,
	glTexCoord2d_FUNC,
	glTexCoord2dv_FUNC,
	glTexCoord2f_FUNC,
	glTexCoord2fv_FUNC,
	glTexCoord2i_FUNC,
	glTexCoord2iv_FUNC,
	glTexCoord2s_FUNC,
	glTexCoord2sv_FUNC,
	glTexCoord3d_FUNC,
	glTexCoord3dv_FUNC,
	glTexCoord3f_FUNC,
	glTexCoord3fv_FUNC,
	glTexCoord3i_FUNC,
	glTexCoord3iv_FUNC,
	glTexCoord3s_FUNC,
	glTexCoord3sv_FUNC,
	glTexCoord4d_FUNC,
	glTexCoord4dv_FUNC,
	glTexCoord4f_FUNC,
	glTexCoord4fv_FUNC,
	glTexCoord4i_FUNC,
	glTexCoord4iv_FUNC,
	glTexCoord4s_FUNC,
	glTexCoord4sv_FUNC,
	glTexCoordPointer_FUNC,
	glTexEnvf_FUNC,
	glTexEnvfv_FUNC,
	glTexEnvi_FUNC,
	glTexEnviv_FUNC,
	glTexGend_FUNC,
	glTexGendv_FUNC,
	glTexGenf_FUNC,
	glTexGenfv_FUNC,
	glTexGeni_FUNC,
	glTexGeniv_FUNC,
	glTexImage1D_FUNC,
	glTexImage2D_FUNC,
	glTexParameterf_FUNC,
	glTexParameterfv_FUNC,
	glTexParameteri_FUNC,
	glTexParameteriv_FUNC,
	glTexSubImage1D_FUNC,
	glTexSubImage2D_FUNC,
	glTranslated_FUNC,
	glTranslatef_FUNC,
	glVertex2d_FUNC,
	glVertex2dv_FUNC,
	glVertex2f_FUNC,
	glVertex2fv_FUNC,
	glVertex2i_FUNC,
	glVertex2iv_FUNC,
	glVertex2s_FUNC,
	glVertex2sv_FUNC,
	glVertex3d_FUNC,
	glVertex3dv_FUNC,
	glVertex3f_FUNC,
	glVertex3fv_FUNC,
	glVertex3i_FUNC,
	glVertex3iv_FUNC,
	glVertex3s_FUNC,
	glVertex3sv_FUNC,
	glVertex4d_FUNC,
	glVertex4dv_FUNC,
	glVertex4f_FUNC,
	glVertex4fv_FUNC,
	glVertex4i_FUNC,
	glVertex4iv_FUNC,
	glVertex4s_FUNC,
	glVertex4sv_FUNC,
	glVertexPointer_FUNC,
	glViewport_FUNC,
} GL_FUNCS;
